//K15.2 `bgT[ovO
import java.net.*;
import java.io.*;
import java.util.*;

public class ChatServer {
   public static void main(String args[]) throws IOException {
      if(args.length != 1) {
        System.out.println("N@: java ChatServer |[gԍ");
            System.out.println(": java ChatServer 2000");
            System.exit(1);
      }
      int port = Integer.valueOf(args[0]).intValue();
      ServerSocket serverS = null;
      boolean end = true;
      try {
           serverS = new ServerSocket(port);
      } catch (IOException e) {
           System.out.println("|[gɃANZXł܂B");
           System.exit(-1);
      }
      while(end){
           new ChatMThread(serverS.accept()).start();
      }
      serverS.close();   
  }
}

class ChatMThread extends Thread {
    Socket socket;
    PrintStream out;
    BufferedReader in;
    static Vector member;
    ChatMThread(Socket s) {
       super("ChatMThread");
       socket = s;

       if (member == null) {
            member = new Vector();
       }
       member.addElement(this);
    }

    public void run() {
      try{
        out = new PrintStream(socket.getOutputStream(), true);
        in = new BufferedReader(
                          new InputStreamReader(socket.getInputStream()));
        String fromClient;
        while ((fromClient = in.readLine()) != null) {
            writeToAll(fromClient);
        }
        end();
        }catch(IOException e){ System.out.println("run:" + e); }
    }

    public void writeToAll(String s) {
       for(Enumeration e = member.elements(); e.hasMoreElements() ;) {
          ChatMThread client = (ChatMThread)e.nextElement();
          client.out.println(s);
        }
    }

    public void end() {
        try {
           in.close();
           out.close();
           socket.close();
        } catch (IOException e) { System.out.println("end:" + e); }
        member.removeElement(this);
    }
}
