//K 11.9 Aj[V
import java.awt.*;
import javax.swing.*;

public class HaikeiAnimation extends JPanel implements Runnable {
    int number = -1;
    int cell = 20;
    int interval;
    Thread animatorThread;
    Image[] image;
    MediaTracker tracker;
    Image haikei;

    public HaikeiAnimation() {
        //C[W̃[h
        tracker = new MediaTracker(this);
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        haikei = toolkit.getImage("rabbit/stage.gif");
        tracker.addImage(haikei, 0);
        image = new Image[cell];
        for (int i = 1; i <= cell; i++) {
            image[i-1] = 
               toolkit.getImage("rabbit/rabbit" + i + ".gif");
            tracker.addImage(image[i-1], 0);
        }

        interval = 150;                  //`̊Ԋu(~b)
        setBackground(Color.white);      //pl̔wiF
        startAnimation();                //Aj[V̊Jn
    }

    public synchronized void startAnimation() {
       //Aj[VJn
       if (animatorThread == null) {
           animatorThread = new Thread(this);
        }
        animatorThread.start();
    }

    public synchronized void stopAnimation() {
        if (animatorThread != null) {//Aj[VXbh~߂
            animatorThread = null;
        }
    }

    public void run() {
      try{
         tracker.waitForAll();
	  }catch(InterruptedException e){ return; }
      while(animatorThread == Thread.currentThread()){
        number++;  //ɕ\C[W̒ʂԍ
        repaint(); //`
        try{
          Thread.sleep(interval);
        }catch(InterruptedException e){ break; }
      }
    }

    public void paintComponent(Graphics g) {
       super.paintComponent(g); //wi̕`
       g.drawImage(haikei, 0, 0, 300, 250, this);
       int x = getWidth()/2-30;  //EBhÊقڒɃC[W\
       int y = getHeight()/2+30;
       try {
           g.drawImage(image[number%cell], x, y, this);
       } catch (ArrayIndexOutOfBoundsException e) { return; }
                                  //number-1̎ɕ`悪Ă΂ꂽ̗O
    }

    public static void main(String[] args) {
        JFrame f = new JFrame("Simple Animation on a stage");
        HaikeiAnimation anime = new HaikeiAnimation();
        f.getContentPane().add(anime, BorderLayout.CENTER);
        f.setSize(new Dimension(300, 250));
        f.setVisible(true);
    }
}





